
#ifndef	STL_COLOR
#define STL_COLOR
#endif

#include <stdio.h>
#include <stdlib.h>
#include "stl.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE		*file;
	Facet		*next,*facet;
	int		color=0;
	unsigned	facets=0;
	char		*rgb,flag[80],*null="",*none=" 1 1 1";

	if (argc!=2) {
	    (void)fputs("usage : stl_mgf STL\n",stderr); exit(1);
	}
	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) {
		(void)fputs("file not found.\n",stderr); exit(1);
	    }

	if ((next=ReadFacet(file))==NULL) {
	    (void)fputs("file read error.\n",stderr); exit(1);
	}
	if (file!=stdin) (void)fclose(file);

	for (facet=next; facet!=NULL; facet=facet->next) {
	    color=color || STL_COLOR_FLAG(facet->flag); ++facets;
	}
	(void)printf("# Micro AVS Geom:2.00\n"
		     "disjoint polygon\n"
		     "from_STL\n"
		     "smooth\n"
		     "%s\n"
		     "%u\n",(color)?"color":"vertex",facets);

	if (!color) rgb=null;

	while ((facet=next)!=NULL) {
	    if (color)
		if (!STL_COLOR_FLAG(facet->flag))
		    rgb=none;
		else
		(void)sprintf(rgb=flag," %lg %lg %lg",STL_COLOR_R(facet->flag),
						      STL_COLOR_G(facet->flag),
						      STL_COLOR_B(facet->flag));

	    (void)printf("3\n"
			 "%f %f %f%s\n"
			 "%f %f %f%s\n"
			 "%f %f %f%s\n",facet->x0,facet->y0,facet->z0,rgb,
					facet->x1,facet->y1,facet->z1,rgb,
					facet->x2,facet->y2,facet->z2,rgb);

	    next=facet->next; free(facet);
	}
	return 0;
}
