
#ifndef	STL_COLOR
#define STL_COLOR
#endif

#include <stdio.h>
#include <stdlib.h>
#include "stl.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*file;
	STL	stl;
	float	x0,y0,z0,x1,y1,z1,x2,y2,z2;
	short	flag;

	if (argc==1) {
	    (void)fputs("usage : stl_raw STL_files\n",stderr); exit(1);
	}
	while (--argc>0) {
	    if (**(++argv)=='-')
		file=stdin;
	    else
		if ((file=fopen(*argv,"rb"))==NULL) {
		    (void)fprintf(stderr,"%s : file not found.\n",*argv);
		    exit(1);
		}

	    if (!SetUpSTL(&stl,file)) {
		(void)fprintf(stderr,"%s : STL header read error.\n",*argv);
		exit(1);
	    }
	    while (ScanSTL(&stl,&x0,&y0,&z0,&x1,&y1,&z1,&x2,&y2,&z2,&flag)>0) {
		if (STL_COLOR_FLAG(flag))
		    (void)printf("%lg %lg %lg ",STL_COLOR_R(flag),
						STL_COLOR_G(flag),
						STL_COLOR_B(flag));

		(void)printf("%f %f %f %f %f %f %f %f %f\n",x0,y0,z0,
							    x1,y1,z1,
							    x2,y2,z2);
	    }
	    if (file!=stdin) (void)fclose(file);
	}
	return 0;
}
